## lua-nginx-redis-connector 0.03

=== Makefile ===
SHELL := /bin/bash # Cheat by using bash :)

OPENRESTY_PREFIX    = /usr/local/openresty-debug

TEST_FILE          ?= t
SENTINEL_TEST_FILE ?= $(TEST_FILE)/sentinel

REDIS_CMD           = redis-server
SENTINEL_CMD        = $(REDIS_CMD) --sentinel

REDIS_SOCK          = /redis.sock
REDIS_PID           = /redis.pid
REDIS_LOG           = /redis.log
REDIS_PREFIX        = /tmp/redis-

# Overrideable redis test variables
TEST_REDIS_PORTS              ?= 6379 6380 6378
TEST_REDIS_DATABASE           ?= 1

REDIS_FIRST_PORT                    := $(firstword $(TEST_REDIS_PORTS))
REDIS_SLAVE_ARG                     := --slaveof 127.0.0.1 $(REDIS_FIRST_PORT)
REDIS_CLI                           := redis-cli -p $(REDIS_FIRST_PORT) -n $(TEST_REDIS_DATABASE)

# Override socket for running make test on its own 
# (make test TEST_REDIS_SOCKET=/path/to/sock.sock)
TEST_REDIS_SOCKET             ?= $(REDIS_PREFIX)$(REDIS_FIRST_PORT)$(REDIS_SOCK)

# Overrideable redis + sentinel test variables
TEST_SENTINEL_PORTS           ?= 6381 6382 6383
TEST_SENTINEL_MASTER_NAME     ?= mymaster
TEST_SENTINEL_PROMOTION_TIME  ?= 20

# Command line arguments for redis tests
TEST_REDIS_VARS     = PATH=$(OPENRESTY_PREFIX)/nginx/sbin:$(PATH) \
TEST_REDIS_SOCKET=unix://$(TEST_REDIS_SOCKET) \
TEST_REDIS_DATABASE=$(TEST_REDIS_DATABASE) \
TEST_NGINX_NO_SHUFFLE=1

# Command line arguments for sentinel tests
TEST_SENTINEL_VARS  = PATH=$(OPENRESTY_PREFIX)/nginx/sbin:$(PATH) \
TEST_SENTINEL_PORT=$(firstword $(TEST_SENTINEL_PORTS)) \
TEST_SENTINEL_MASTER_NAME=$(TEST_SENTINEL_MASTER_NAME) \
TEST_REDIS_DATABASE=$(TEST_REDIS_DATABASE) \
TEST_NGINX_NO_SHUFFLE=1

# Sentinel configuration can only be set by a config file
define TEST_SENTINEL_CONFIG
sentinel       monitor $(TEST_SENTINEL_MASTER_NAME) 127.0.0.1 $(REDIS_FIRST_PORT) 2
sentinel       down-after-milliseconds $(TEST_SENTINEL_MASTER_NAME) 2000
sentinel       failover-timeout $(TEST_SENTINEL_MASTER_NAME) 10000
sentinel       parallel-syncs $(TEST_SENTINEL_MASTER_NAME) 5
endef

export TEST_SENTINEL_CONFIG

SENTINEL_CONFIG_FILE = /tmp/sentinel-test-config


PREFIX          ?= /usr/local
LUA_INCLUDE_DIR ?= $(PREFIX)/include
LUA_LIB_DIR     ?= $(PREFIX)/lib/lua/$(LUA_VERSION)
PROVE           ?= prove -I ../test-nginx/lib
INSTALL         ?= install

.PHONY: all install test test_all start_redis_instances stop_redis_instances \
	start_redis_instance stop_redis_instance cleanup_redis_instance flush_db \
	create_sentinel_config delete_sentinel_config check_ports test_redis \
	test_sentinel sleep

all: ;

install: all
	$(INSTALL) -d $(DESTDIR)/$(LUA_LIB_DIR)/resty/redis
	$(INSTALL) lib/resty/redis/*.lua $(DESTDIR)/$(LUA_LIB_DIR)/resty/redis

test: test_redis
test_all: start_redis_instances sleep test_redis stop_redis_instances

sleep:
	sleep 3

start_redis_instances: check_ports create_sentinel_config
	@$(foreach port,$(TEST_REDIS_PORTS), \
		[[ "$(port)" != "$(REDIS_FIRST_PORT)" ]] && \
			SLAVE="$(REDIS_SLAVE_ARG)" || \
			SLAVE="" && \
		$(MAKE) start_redis_instance args="$$SLAVE" port=$(port) \
		prefix=$(REDIS_PREFIX)$(port) && \
	) true

	@$(foreach port,$(TEST_SENTINEL_PORTS), \
		$(MAKE) start_redis_instance \
		port=$(port) args="$(SENTINEL_CONFIG_FILE) --sentinel" \
		prefix=$(REDIS_PREFIX)$(port) && \
	) true


stop_redis_instances: delete_sentinel_config 
	-@$(foreach port,$(TEST_REDIS_PORTS) $(TEST_SENTINEL_PORTS), \
		$(MAKE) stop_redis_instance cleanup_redis_instance port=$(port) \
		prefix=$(REDIS_PREFIX)$(port) && \
	) true 2>&1 > /dev/null


start_redis_instance:
	-@echo "Starting redis on port $(port) with args: \"$(args)\""
	-@mkdir -p $(prefix)
	@$(REDIS_CMD) $(args) \
		--pidfile $(prefix)$(REDIS_PID) \
		--bind 127.0.0.1 --port $(port) \
		--unixsocket $(prefix)$(REDIS_SOCK) \
		--unixsocketperm 777 \
		--dir $(prefix) \
		--logfile $(prefix)$(REDIS_LOG) \
		--loglevel debug \
		--daemonize yes

stop_redis_instance:
	-@echo "Stopping redis on port $(port)"
	-@[[ -f "$(prefix)$(REDIS_PID)" ]] && kill -QUIT \
	`cat $(prefix)$(REDIS_PID)` 2>&1 > /dev/null || true

cleanup_redis_instance: stop_redis_instance
	-@echo "Cleaning up redis files in $(prefix)"
	-@rm -rf $(prefix)

flush_db:
	-@echo "Flushing Redis DB"
	@$(REDIS_CLI) flushdb

create_sentinel_config:
	-@echo "Creating $(SENTINEL_CONFIG_FILE)"
	@echo "$$TEST_SENTINEL_CONFIG" > $(SENTINEL_CONFIG_FILE)

delete_sentinel_config:
	-@echo "Removing $(SENTINEL_CONFIG_FILE)"
	@rm -f $(SENTINEL_CONFIG_FILE)

check_ports:
	-@echo "Checking ports $(REDIS_PORTS)"
	@$(foreach port,$(REDIS_PORTS),! lsof -i :$(port) &&) true 2>&1 > /dev/null

test_redis: flush_db
	$(TEST_REDIS_VARS) $(PROVE) $(TEST_FILE)
	util/lua-releng

test_leak: flush_db
	$(TEST_REDIS_VARS) TEST_NGINX_CHECK_LEAK=1 $(PROVE) $(TEST_FILE)

=== debian/changelog ===
lua-nginx-redis-connector (0.03-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 14 Dec 2015 22:41:39 +0800

lua-nginx-redis-connector (0.02-1) unstable; urgency=low

  * Initial release. Closes: #806838

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 02 Dec 2015 10:30:22 +0800

=== debian/control ===
Source: lua-nginx-redis-connector
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Section: interpreters
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-lua,
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/lua-nginx-redis-connector.git/?h=debian/sid
Vcs-Git: git://anonscm.debian.org/collab-maint/lua-nginx-redis-connector.git -b debian/sid
Homepage: https://github.com/pintsized/lua-resty-redis-connector

Package: lua-nginx-redis-connector
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lua-nginx-redis
Description: Connection utilities for lua-nginx-redis
 Connection utilities for lua-resty-redis, making it easy and reliable to
 connect to Redis hosts, either directly or via Redis Sentinel.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_configure:
	perl -i -pe s/resty/nginx/g lib/resty/redis/*.lua
	dh_auto_configure

override_dh_auto_clean:
	dh_auto_clean
	perl -i -pe s/nginx/resty/g lib/resty/redis/*.lua

=== debian/watch ===
version=3
https://github.com/pintsized/lua-resty-redis-connector/releases .*/v([\d\.]*)\.tar.gz

## lua-nginx-redis-connector 0.04

=== debian/changelog ===
lua-nginx-redis-connector (0.04-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.0.0.
  * Bump compat to 10.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 23 Jul 2017 15:15:40 +0800

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
 Section: interpreters
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                dh-lua,
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/lua-nginx-redis-connector.git/?h=debian/sid
-Vcs-Git: git://anonscm.debian.org/collab-maint/lua-nginx-redis-connector.git -b debian/sid
+Standards-Version: 4.0.0
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/lua-nginx-redis-connector.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/lua-nginx-redis-connector.git
 Homepage: https://github.com/pintsized/lua-resty-redis-connector
 
 Package: lua-nginx-redis-connector

## lua-nginx-redis-connector 0.06

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 SHELL := /bin/bash # Cheat by using bash :)
 
-OPENRESTY_PREFIX    = /usr/local/openresty-debug
+OPENRESTY_PREFIX    = /usr/local/openresty
 
 TEST_FILE          ?= t
 SENTINEL_TEST_FILE ?= $(TEST_FILE)/sentinel
@@ -21,7 +21,7 @@
 REDIS_SLAVE_ARG                     := --slaveof 127.0.0.1 $(REDIS_FIRST_PORT)
 REDIS_CLI                           := redis-cli -p $(REDIS_FIRST_PORT) -n $(TEST_REDIS_DATABASE)
 
-# Override socket for running make test on its own 
+# Override socket for running make test on its own
 # (make test TEST_REDIS_SOCKET=/path/to/sock.sock)
 TEST_REDIS_SOCKET             ?= $(REDIS_PREFIX)$(REDIS_FIRST_PORT)$(REDIS_SOCK)
 
@@ -95,7 +95,7 @@
 	) true
 
 
-stop_redis_instances: delete_sentinel_config 
+stop_redis_instances: delete_sentinel_config
 	-@$(foreach port,$(TEST_REDIS_PORTS) $(TEST_SENTINEL_PORTS), \
 		$(MAKE) stop_redis_instance cleanup_redis_instance port=$(port) \
 		prefix=$(REDIS_PREFIX)$(port) && \
@@ -141,8 +141,11 @@
 	@$(foreach port,$(REDIS_PORTS),! lsof -i :$(port) &&) true 2>&1 > /dev/null
 
 test_redis: flush_db
+	util/lua-releng
+	@rm -f luacov.stats.out
 	$(TEST_REDIS_VARS) $(PROVE) $(TEST_FILE)
-	util/lua-releng
+	@luacov
+	@tail -7 luacov.report.out
 
 test_leak: flush_db
 	$(TEST_REDIS_VARS) TEST_NGINX_CHECK_LEAK=1 $(PROVE) $(TEST_FILE)

=== debian/changelog ===
lua-nginx-redis-connector (0.06-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.2.
  * Update Vcs-* fields to salsa.debian.org.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 23 Dec 2017 17:07:25 +0800

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Priority: optional
 Build-Depends: debhelper (>= 10),
                dh-lua,
-Standards-Version: 4.0.0
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/lua-nginx-redis-connector.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/lua-nginx-redis-connector.git
+Standards-Version: 4.1.2
+Vcs-Browser: https://salsa.debian.org/debian/lua-nginx-redis-connector
+Vcs-Git: https://salsa.debian.org/debian/lua-nginx-redis-connector.git
 Homepage: https://github.com/pintsized/lua-resty-redis-connector
 
 Package: lua-nginx-redis-connector
